============================================================================

Introduction
============
This package is used to manipulate various measurement file types to enable
easy and efficient organisation of the data from MATLAB and PYTHON.

Currently supported formats are:

1. C3D (.c3d) Motion capture files.
2. CSV (.csv) with all values as numeric.
3. GCE (.gce) from the http://chomsky.shampoo.ca/goldenembed/ ANT logger project.
4. ANT (.ant) from the https://github.com/mvillalba/python-ant ANT USB logger project.
5. TAB (.tab) ADAMS (Msc Software) export 'table' files import.


The project imports the data into (HDF5)[http://www.hdfgroup.org/HDF5/] using
PyTables and provides software for easily accessing the data from MATLAB and
PYTHON.

The project is part of the SOFIE project at the University of Twente,
[http://mobilitylabtwente.nl/sofie] and the project is hosted at
[https://github.com/agcooke/Sofie-HDF-Format]

Contact
-------
Contact via:
    vera "dot" bulsink {at} u t wente 'dot' nl with all the correct symbols
replaced and whitespace removed.

Dependencies
------------
- (Pytables:)[http://www.pytables.org/], pip tables or apt-get install python-tables. If you
  install from pip in ubuntu you need 'libhdf5-serial-dev' to get it to compile.
  
The rest of the dependencies are handled by (pip)[http://pypi.python.org/pypi/pip].  

License
-------
Released under the BSD-3-Clause license. See LICENSE for the full text.

Install
===========
Linux:
-------
Clone from git hub or download a latest tag.
If you install from pip in ubuntu you need 'libhdf5-serial-dev' to get it to compile.
	$ sudo apt-get install libhdf5-serial-dev

Install if you would like to:
	$ pip install -e git+git://github.com/agcooke/Sofie-HDF-Format.git#egg=sofiehdfformat
	
The main script is
found in sofiehdfformat/bin/sofie-hdf-format.py with help available from the
command line 'sofie-hdf-format.exe -h'.


Windows install instructions (for a normal user):
-------------------------------------------------
If you would like to use the SOFIE HDF FORMAT software then there are
pre compiled binaries available for download here:
https://github.com/agcooke/Sofie-HDF-Format/win32build

Then run the software 'sofie-hdf-format.exe -h' to see how to use it. Enjoy!

Windows install instructions (for a developer):
-------------------------------------------------
To create a full development environment follow the instructions found on
this page:

http://adriangerardcooke.com/installing-python-on-windows/,

then clone SOFIE HDF FORMAT from github and you have the latest working 
environment. It is also possible to install (PythonXY)[http://code.google.com/p/pythonxy/]
to get a full development environment, which can be much simpler.

MATLAB
-----------------------------------------------
The MATLAB scripts are found in sofiehdfformat/matlabchain. If you would like
to use these scripts in Matlab then add all the directories and files in
'sofiehdfformat/matlabchain' to your Matlab path, EXCEPT the 'test' directory.
