"""
The Class that us used to process data from the ANT sensor and write to
the SOFIEHDFFORMAT.
"""
from sofiehdfformat.antpytableaccess.AntTableStructure import ANTPARSERPARSEDLISTLENTH
from sofiehdfformat.antpytableaccess.AntTableStructure import ANTPARSERRAWLISTLENTH
from sofiehdfformat.antpytableaccess.AntTableStructure import AntParsedData
from sofiehdfformat.antpytableaccess.AntTableStructure import AntParsedDataName
from sofiehdfformat.antpytableaccess.AntTableStructure import AntRawData
from sofiehdfformat.antpytableaccess.AntTableStructure import AntRawDataName
from sofiehdfformat.core.SofieHdfFormatExceptions import AntParserLengthNotCorrect
from sofiehdfformat.core.SofieHdfFormatExceptions import AntRawParserLengthNotCorrect
from sofiehdfformat.core.SofiePyTableAccess import SofiePyTableAccess
from tables import *
#import numpy.rec
class AntRawDataAccess(SofiePyTableAccess):
    
    def __init__(self,filename,runName='/test',description=''):
        SofiePyTableAccess.__init__(self,filename,runName=runName,
            description=description);
        self.setTable(AntRawDataName,AntRawData)
    
    def write(self,thePayloadList):
        """ Writes the data into a table with each byte in a separate column. 
        
        Throws an IncorrectAntDataError if thePayloadList is not equal 
        to sofiehdfformat.AntParser.ANTDATALENGTH
        """
        if len(thePayloadList)!=ANTPARSERRAWLISTLENTH:
            raise AntRawParserLengthNotCorrect()
        SofiePyTableAccess.write(self,thePayloadList)

class AntParsedDataAccess(SofiePyTableAccess):

    def __init__(self,filename,runName='/test'):
        SofiePyTableAccess.__init__(self,filename,runName);
        self.setTable(AntParsedDataName, AntParsedData)

    def write(self,thePayloadList):
        """ Writes the data into a table with each byte in a separate column.

        Throws an IncorrectAntDataError if thePayloadList is not equal
        to sofiehdfformat.AntParser.ANTDATALENGTH
        """
        if len(thePayloadList)!=ANTPARSERPARSEDLISTLENTH:
            raise AntParserLengthNotCorrect('The length should be: '+\
                str(ANTPARSERPARSEDLISTLENTH)+
                ': BUT is: '+ str(len(thePayloadList))
                )
        SofiePyTableAccess.write(self,thePayloadList)