import logging
from tables.description import IsDescription
# To change this template, choose Tools | Templates
# and open the template in the editor.
__author__="cooke"
__date__ ="$29-Sep-2011 15:32:40$"
from tables import *

""" The structure of the ANT Raw Table. """
class AntRawData(IsDescription):
    ChanID = UInt8Col(pos=1)
    BikeCadenceEventTimeLSB = UInt8Col(pos=2)
    BikeCadenceEventTimeMSB = UInt8Col(pos=3)
    CumulativeCadenceRevolutionCountLSB = UInt8Col(pos=4)
    CumulativeCadenceRevolutionCountMSB = UInt8Col(pos=5)
    BikeSpeedEventTimeLSB = UInt8Col(pos=6)
    BikeSpeedEventTimeMSB = UInt8Col(pos=7)
    CumulativeSpeedRevolutionCountLSB = UInt8Col(pos=8)
    CumulativeSpeedRevolutionCountMSB = UInt8Col(pos=9)
    Timestamp = FloatCol(pos=10)
AntRawDataName='AntRawData'

""" The structure of the ANT Parsed Table. """
class AntParsedData(IsDescription):
    BikeCadenceEventTime = Float32Col(pos=1)
    CumulativeCadenceRevolutionCount = Float32Col(pos=2)
    BikeSpeedEventTime = Float32Col(pos=3)
    CumulativeSpeedRevolutionCount = Float32Col(pos=4)
    BikeCadence = Float32Col(pos=5)
    BikeSpeed = Float32Col(pos=6)
    BikeCadenceHoldTimestamp = Float64Col(pos=7)
    BikeSpeedHoldTimestamp = Float64Col(pos=8)
    Timestamp = Float64Col(pos=9)
AntParsedDataName='AntParsedData'

#RAW ANT DATA
ANTCADENCEDATALENGTH=9
ANTHEADERPACKETLEN=4 #SYNC, CHECKSUM, ?, LENGTHBIT
ANTCADENCESPEEDTOTALLENGHT=ANTHEADERPACKETLEN+ANTHEADERPACKETLEN
ANTPARSERRAWLISTLENTH=ANTCADENCEDATALENGTH+1 # The timestamp.

#PARSED ANT DATA
ANTPARSERPARSEDLISTLENTH=9