import logging
from sofiehdfformat.core.SofiePyTableAccess import SofiePyTableAccess
from sofiehdfformat.core.SofieTableStructure import CsvImportDataName
from tables import FloatCol
class SofieCsvPyTableAccess(SofiePyTableAccess):
    """ Handles the writing of CSV files to the sofiehdfformat' """
    
    def __init__(self,filename,runName='/test',fieldNames={},description=''):
        """
        For now only handles CSV files where all columns are float.
        """
        SofiePyTableAccess.__init__(self,filename,runName=runName,
            description=description,allowDuplicates=True);
        fieldNamesDict = {}
        for field in fieldNames:
            fieldNamesDict[self._makesafekey(field)] = FloatCol()
        self.setTable(CsvImportDataName,fieldNamesDict)
    
    def write(self,thePayloadList):
        """ Writes the data into a table with each byte in a separate column. 
        """
        logging.debug(thePayloadList)
        newPayLoadList = {}
        for key in thePayloadList.keys():
            newPayLoadList[self._makesafekey(key)] = thePayloadList[key]
            if thePayloadList[key] == None:
                continue
            if isinstance(thePayloadList[key], basestring):
                converted = thePayloadList[key].strip('\'')
                if len(converted) == 0 or converted == None:
                    newPayLoadList[self._makesafekey(key)] = None
                else:
                    logging.debug(thePayloadList[key].strip('\''))
                    newPayLoadList[self._makesafekey(key)] = float(converted)
        logging.debug(newPayLoadList)

        SofiePyTableAccess.write(self,newPayLoadList)
