'''
File to consolidate working with Paths within the SOFIE HDF File and other configuration options.
'''
GESUBDIRECTORY='goldenembeded'
SPARKSUBDIRECTORY='sparkfunusb'
C3DSUBDIRECTORY='c3d'
CSVSUBDIRECTORY='csvimport'
ADAMSSUBDIRECTORY='adams'
BAGSUBDIRECTORY='bags'
ARRUNEXTENSION='ar'
ARDUINORUNEXTENSION='arduino'
USBCAMTMPFILE='usbcam.bag'
CSVTMPFILE='tmp.csv'

def _combinePaths(thePathList):
    if thePathList:
        return '/'+'/'.join(['']+thePathList).strip('/').replace('.','')
    else:
        return '/'

def getGESubDirectory(runName):
    return _combinePaths([runName,GESUBDIRECTORY]);
def getSparkSubDirectory(runName):
    return _combinePaths([runName,SPARKSUBDIRECTORY]);
def getC3DSubDirectory(runName):
    return _combinePaths([runName,C3DSUBDIRECTORY]);
def getAdamsSubDirectory(runName):
    return _combinePaths([runName,ADAMSSUBDIRECTORY]);
def getCSVImportSubDirectory(runName):
    return _combinePaths([runName,CSVSUBDIRECTORY]);
def getARSubDirectory(runName):
    return _combinePaths([runName,ARRUNEXTENSION]);
def getArduinoSubDirectory(runName):
    return _combinePaths([runName,ARDUINORUNEXTENSION]);
def getBagSubDirectory(runName):
    return _combinePaths([runName,BAGSUBDIRECTORY]);
def getDefaultBagFile(runName):
    ''' For inside the Pytables '''
    return _combinePaths([runName,USBCAMTMPFILE]);
def getDefaultBagFileName():
    ''' For exporting the file '''
    return USBCAMTMPFILE
def getDefaultCSVFileName():
    ''' For exporting the file '''
    return CSVTMPFILE