classdef adamsReader < h5Reader
    %Adams Reader - Reads data from the H5 file that was imported from an
    % Msc Software Adams tab file (table export).
    
    properties (Constant)
        tablePreamble = '/CsvImportData'
        lastDirectory = '/adams'
    end
    
    methods
        function prD = adamsReader(filename,runName)
            if nargin > 0 % Support calling with 0 arguments
                prD.filename = filename;
                runName = [runName prD.lastDirectory];
                prD.runName = runName;       
                prD.currentPos = runName;
                disp(prD.currentPos);
            end 
        end %Constructor
        
        function data = readData(prD,varargin)
           data = prD.readLeafData(...
               [prD.tablePreamble],varargin{:});
         end % readData
    end
end