classdef h5Writer < h5Reader
    %   H5Writer Class to Write to a HDF file.
    %
    % BE VERY CAREFUL, this only works for a single file and replaces all
    % data in the file.
    
    
    
    methods
        function h5R = h5Writer(filename,runName)
            %Choose the file to access with the run which you would like
            %to read.
            
            h5R@h5Reader(filename,runName);
            
        end %Constructor
        
        
        function writeLeafData(h5W,leafName,dataToWrite)
            % Writes to the file. Overwrites all data.
            disp(h5W.filename)
            disp([h5W.currentPos,'/',leafName])
            error(nargchk(1,3,nargin,'struct'));
            dataToWrite = dataToWrite';
            try
                h5filecreate(h5W.filename);
            catch err
                display(err);
            end
            
                h5datacreate(h5W.filename,...
                     ['/',h5W.currentPos,'/',leafName],...
                    'size',size(dataToWrite),'chunk_size',size(dataToWrite));

             h5varput(h5W.filename,...
                ['/',h5W.currentPos,'/',leafName],...
                dataToWrite);
            
        end % writeLeafData
    end
    
end

