import logging
import os
from os import unlink
import unittest

from sofiehdfformat.c3dpytableaccess.C3DPyTableAccess import C3DDataAccess
import sofiehdfformat.c3dreader.c3dreader as C3
from sofiehdfformat.core.SofieCsvAccess import SofieCsvAccess
class C3DTableAccessTest (unittest.TestCase):
    def setUp(self):
        if os.path.isfile('c3d-test-data.h5'):
           unlink('c3d-test-data.h5')
        logging.info('AntRawDataAccess Test')
        self.c3dFile = C3.open('test-data/test.c3d')
        self.cwriter = C3DDataAccess('c3d-test-data.h5','/test',
            videoSamplingRate=self.c3dFile.getVideoSamplingRate(),
            videoFrames=self.c3dFile.getVideoFrames(),
            scale=self.c3dFile.getScale()
            )

    def tearDown(self):
        self.cwriter.close()
        self.c3dFile.close()

    def test_write_read(self):
        while True:
            second = self.c3dFile.readline()
            if second == False:
                break;
            #outFile.write(second+'\n')
            self.assertIsInstance(second,dict);
            self.cwriter.write(second)
            
        csvWriter = SofieCsvAccess('c3d-test-data.csv')
        numRows = 0
        for row in self.cwriter:
            #logging.debug(row)
            csvWriter.write(row)
            numRows += 1
        self.assertEqual(self.c3dFile.getVideoFrames(),numRows)

def suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(C3DTableAccessTest))
    return suite

if __name__ == '__main__':
    runner = unittest.TextTestRunner()
    test_suite = suite()
    runner.run (test_suite)
    