import logging
import unittest
from sofiehdfformat.core.SofieUtils import convertRawDataToHexString
import sofiehdfformat.sparkfunantusbreader.SparkFunFile as SF
class SparkFunTableTest (unittest.TestCase):
    def setUp(self):
        logging.info('SparkFunTableTest Test')
        self.file = SF.open('test-data/simple-test-data.ant')
        
    def tearDown(self):
        pass
        
    def test_open(self):
        self.assertIsInstance(self.file,SF.SparkFunFile);
        
    def test_readline(self):
         #outFile = open('ant-string-dump.txt','w')
        logging.debug('Reading fist time.')
        first = self.file.readline()
        self.assertIsInstance(first,dict);
        self.assertEqual(convertRawDataToHexString(first['packet']),\
            'A4 03 40 00 46 00 A1')
        self.assertEqual(first['timestamp'],1319111443)

        #outFile.write(first+'\n')
        logging.debug('Reading second time:'+str(len(first)))
        second = self.file.readline()
        self.assertIsInstance(second,dict);
        self.assertEqual(convertRawDataToHexString(second['packet']),\
            'A4 03 40 00 42 00 A5')
        self.assertEqual(second['timestamp'],1319111443)
        self.assertNotEqual(first,second)

        #outFile.write(second+'\n')
        while True:
            second = self.file.readline()
            if second == False:
                break;
            #outFile.write(second+'\n')
            self.assertIsInstance(second,dict);
    def test_close(self):
        self.assertEqual(self.file.close(),None);
def suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(SparkFunTableTest))
    return suite

if __name__ == '__main__':
    runner = unittest.TextTestRunner()
    test_suite = suite()
    runner.run (test_suite)